/// RAII - Resource Aquisition Is Initialization

#include <iostream>
#include <fstream>

template <class T>
class Vector {
public:
    /// Functii memmbre Speciale
    Vector() : n {0}, ptr {nullptr}
    {}

    Vector(int n, const T& val = T())
        : n {n}, ptr {new T[n]}
    {
        for (size_t i = 0; i < n; ++i)
            ptr[i] = val;
    }
    /// copy constructor
    Vector(const Vector& v) :
        n{v.n}, ptr {new T[n]}
    {
        for (size_t i = 0; i < n; ++i)
            ptr[i] = v.ptr[i];
    }

    ~Vector()
    {
        if (ptr != nullptr)
            delete[] ptr;
    }

    /// Tipuri membre
    using iterator = T*;
    using const_iterator = const T*;
    using reference = T&;
    using const_reference = const T&;
    using pointer = T*;

    /// Functii Membre
    iterator begin() const
    {
        return ptr;
    }

    iterator end() const
    {
        return ptr + n;
    }

    bool empty() const
    {
        return n == 0;
    }

private:
   /// Date Membre
    size_t n;
    T* ptr;
};

int main()
{
    Vector<int> v(10);

    for (Vector<int>::iterator it = v.begin();
            it != v.end(); ++it)
            std::cout << *it << ' ';
    {

        Vector<int> v1 {v}; /// v1 creat prin copiere
    }

    return 0;
}
